#ifdef GL_ES
    precision mediump float;
#endif

varying vec4 v_color;
varying vec2 v_texCoords;
uniform sampler2D u_texture;

void main() {
    #define DIV_SQRT_2 0.70710678118

    // These are hardcoded based on the resolution (width = 2/800, height = 2/480), could be calculated dynamically though
    #define WIDTH 0.0025
    #define HEIGHT 0.0042

    vec4 color = texture2D(u_texture, v_texCoords);

    float minAlpha = color.a;

    minAlpha = min(minAlpha, texture2D(u_texture, v_texCoords + vec2(WIDTH, 0)).a);
    minAlpha = min(minAlpha, texture2D(u_texture, v_texCoords + vec2(0, HEIGHT)).a);
    minAlpha = min(minAlpha, texture2D(u_texture, v_texCoords + vec2(-WIDTH, 0)).a);
    minAlpha = min(minAlpha, texture2D(u_texture, v_texCoords + vec2(0, -HEIGHT)).a);

    minAlpha = min(minAlpha, texture2D(u_texture, v_texCoords + vec2(-WIDTH, -HEIGHT) * DIV_SQRT_2).a);
    minAlpha = min(minAlpha, texture2D(u_texture, v_texCoords + vec2(WIDTH, HEIGHT) * DIV_SQRT_2).a);
    minAlpha = min(minAlpha, texture2D(u_texture, v_texCoords + vec2(-WIDTH, HEIGHT) * DIV_SQRT_2).a);
    minAlpha = min(minAlpha, texture2D(u_texture, v_texCoords + vec2(WIDTH, -HEIGHT) * DIV_SQRT_2).a);

    color.rgb = mix(vec3(0.0, 0.0, 0.0), color.rgb, minAlpha);

    gl_FragColor = color;
}